program OsmKostek;
{$APPTYPE CONSOLE}
uses
  SysUtils;

const
  MAX_CNT = 10000;
  N = 8;

type
  TPos = record
    X,Y : Byte;
  end;
  TState = array[1..N] of Byte;
  TConfs = array[1..N] of Boolean;
  TMove = record
    Col,NewPos : Byte;
  end;

function FindConflicts(St : TState; var Confs : TConfs) : Boolean;
var I,J : Byte;
begin
  Result:=False;
  for I:=1 to N do begin
    Confs[I]:=False;
    for J:=1 to N do begin
      if I<>J then begin
        if (St[I]=St[J]) or ((I-St[I])=(J-St[J])) or ((I+St[I])=(J+St[J])) then begin
          Confs[I]:=True;
          Result:=True;
          Break;
        end;
      end;
    end;
  end;
end;

function GetConflict(St : TState; Col : Byte; Pos : Byte) : Byte;
var J : Byte;
begin
  Result:=0;
  for J:=1 to N do begin
    if Col<>J then begin
      if (Pos=St[J]) or ((Col-Pos)=(J-St[J])) or ((Col+Pos)=(J+St[J])) then Inc(Result);
    end;
  end;
end;

function FindNextMove(St : TState; var Move : TMove) : Boolean;
var I,J,X,Min : Byte;
    Cf : TConfs;
begin
  Result:=False;
  Min:=N+1;
  if FindConflicts(St,Cf) then begin
    for I:=1 to N do begin
      if Cf[I] then begin
        for J:=1 to N do begin
          if St[I]<>J then begin
            X:=GetConflict(St,I,J);
            if X<Min then begin
              Move.Col:=I;
              Move.NewPos:=J;
              Min:=X;
            end else begin
              {Nadnostni vyber -->}
              if (X=Min) and (Random(2)=1) then begin
                Move.Col:=I;
                Move.NewPos:=J;
                Min:=X;
              end;
              {<--}
            end;
          end;
        end;
      end;
    end;
    Result:=True;
  end;
end;

function OsmDam(var St : TState; var Cnt : Integer) : Boolean;
var Mv : TMove;
begin
  Result:=False;
  while FindNextMove(St,Mv) do begin
    St[Mv.Col]:=Mv.NewPos;
    Inc(Cnt);
    if Cnt>MAX_CNT then Exit;
  end;
  Result:=True;
end;

procedure CopyState(var StFrom, StTo : TState);
var I : Byte;
begin
  for I:=1 to N do StTo[I]:=StFrom[I];
end;

procedure WriteState(var St : TState);
var I,J : Byte;
begin
  WriteLn('  |A B C D E F G H');
  WriteLn('-------------------');
  for I:=1 to N do begin
    Write(' '+IntToStr(I)+'|');
    for J:=1 to N do begin
      if St[J]=I then Write('<>') else Write('  ');
    end;
    WriteLn('');
    // WriteLn(Format(' %d|%*s',[I,2*St[I],'<>']));
  end;
  WriteLn('-------------------');
end;


var State : TState;
    PocState : TState;
    Cnt : Integer;
    I : Byte;
begin
  WriteLn('Osm dam :');
  State[1]:=2;
  State[2]:=5;
  State[3]:=7;
  State[4]:=4;
  State[5]:=1;
  State[6]:=3;
  State[7]:=6;
  State[8]:=8;
  //for I:=1 to N do State[I]:=((2*I-1) mod 8);
  //for I:=1 to N do State[I]:=I;
  //for I:=1 to N do State[I]:=1;
  Randomize;
  CopyState(State,PocState);
  WriteState(State);
  if OsmDam(State,Cnt) then begin
    WriteState(State);
    WriteLn('OK ('+IntToStr(Cnt)+')');
  end else begin
    WriteLn('NENALEZENO');
  end;
  ReadLn;
end.

